// PPgBackup.cpp : implementation file
// Partialy based on emule 0.26d_Fusion_Flux_[R6]

#include "stdafx.h"
#include "emule.h"
#include "PPgBackup.h"
#include "string.h"
#include "AddBuddy.h"

// CPPgBackup dialog
IMPLEMENT_DYNAMIC(CPPgBackup, CPropertyPage)
CPPgBackup::CPPgBackup()
: CPropertyPage(CPPgBackup::IDD)
, datFiles(FALSE)
, metFiles(FALSE)
, iniFiles(FALSE)
, partFiles(FALSE)
, partMetFiles(FALSE)
, autoBackup(FALSE)
, overwriteFiles(FALSE)
, backupDir(_T(""))
, backupTypeDesc(_T(""))
, backupOptionDesc(_T(""))
, backupDirDesc(_T(""))
, scheduledBackup(FALSE)
, scheduledBackupInterval(_T(""))
{
}

CPPgBackup::~CPPgBackup()
{
}

void CPPgBackup::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_DAT, datFiles);
	DDX_Check(pDX, IDC_MET, metFiles);
	DDX_Check(pDX, IDC_INI, iniFiles);
	DDX_Check(pDX, IDC_PART, partFiles);
	DDX_Check(pDX, IDC_PARTMET, partMetFiles);
	DDX_Check(pDX, IDC_BACKUP_AUTO, autoBackup);
	DDX_Check(pDX, IDC_BACKUP_OVERWRITE, overwriteFiles);
	DDX_Text(pDX, IDC_BACKUP_DIR, backupDir);
	DDX_Text(pDX, IDC_BACKUP_GRPFILETYPE, backupTypeDesc);
	DDX_Control(pDX, IDC_BACKUP_SELECTALL, selectAllButton);
	DDX_Control(pDX, IDC_BACKUP_NOW, backupNowButton);
	DDX_Text(pDX, IDC_BACKUP_OPTION, backupOptionDesc);
	DDX_Text(pDX, IDC_BACKUP_TITLETXT, backupDirDesc);
	DDX_Control(pDX, IDC_BACKUP_OVERWRITE, overwriteFilesCheck);
	DDX_Control(pDX, IDC_BACKUP_AUTO, autoBackupCheck);
	DDX_Control(pDX, IDC_BACKUP_DIR, backupDirEdit);
	DDX_Control(pDX, IDC_BACKUP_BROWSE, backupBrowseButton);
	DDX_Check(pDX, IDC_SCHEDULED_BACKUP, scheduledBackup);
	DDX_Control(pDX, IDC_SCHEDULED_BACKUP, scheduledBackupCheck);
	DDX_Control(pDX, IDC_SCHEDULED_BACKUP_INTERVAL, scheduledBackupEdit);
	DDX_Text(pDX, IDC_SCHEDULED_BACKUP_INTERVAL, scheduledBackupInterval);
	DDX_Text(pDX, IDC_HOURS, hours);
}

BOOL CPPgBackup::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	LoadSettings();
	CheckBackupNowButton();

	AddBuddy(backupDirEdit.m_hWnd, backupBrowseButton.m_hWnd, BDS_RIGHT);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

BEGIN_MESSAGE_MAP(CPPgBackup, CPropertyPage)
	ON_BN_CLICKED(IDC_BACKUP_NOW, OnBnClickedBackupnow)
	ON_BN_CLICKED(IDC_DAT, OnBnClickedDat)
	ON_BN_CLICKED(IDC_MET, OnBnClickedMet)
	ON_BN_CLICKED(IDC_INI, OnBnClickedIni)
	ON_BN_CLICKED(IDC_PART, OnBnClickedPart)
	ON_BN_CLICKED(IDC_PARTMET, OnBnClickedPartMet)
	ON_BN_CLICKED(IDC_BACKUP_SELECTALL, OnBnClickedSelectall)
	ON_BN_CLICKED(IDC_AUTOBACKUP, OnBnClickedAutobackup)
	ON_BN_CLICKED(IDC_BACKUP_OVERWRITE, OnBnClickedOverwrite)
	ON_BN_CLICKED(IDC_BACKUP_BROWSE, OnBnClickedBrowse)
	ON_EN_CHANGE(IDC_BACKUP_DIR, OnEnChangeBackupDir)
	ON_BN_CLICKED(IDC_BACKUP_AUTO, OnBnClickedBackupAuto)
	ON_BN_CLICKED(IDC_SCHEDULED_BACKUP, OnBnClickedScheduledBackupCheck)
	ON_EN_CHANGE(IDC_SCHEDULED_BACKUP_INTERVAL, OnEnChangeScheduledBackupInterval)
END_MESSAGE_MAP()


void CPPgBackup::OnBnClickedDat()
{
	SetModified();
	CheckBackupNowButton();
}

void CPPgBackup::OnBnClickedMet()
{
	SetModified();
	CheckBackupNowButton();
}

void CPPgBackup::OnBnClickedIni()
{
	SetModified();
	CheckBackupNowButton();
}

void CPPgBackup::OnBnClickedPart()
{
	UpdateData(TRUE);

	if (partFiles)
	{
		if (MessageBox(GetResString(IDS_BACKUP_LONGTIME),GetResString(IDS_BACKUP_SURE),MB_ICONQUESTION|MB_YESNO)== IDYES)
		{
			partFiles = true;
			CheckBackupNowButton();
		}
		else
			partFiles = false;
	}

	UpdateData(FALSE);
	SetModified();
}

void CPPgBackup::OnBnClickedPartMet()
{
	SetModified();
	CheckBackupNowButton();
}

void CPPgBackup::OnBnClickedBackupAuto()
{
	SetModified();
}

void CPPgBackup::OnBnClickedOverwrite()
{
	SetModified();
}

void CPPgBackup::OnBnClickedBrowse()
{
	TCHAR buffer[MAX_PATH];	
	if(SelectDir(buffer,GetResString(IDS_SELECT_BACKUPDIR)))
	{
		backupDir = buffer;
		UpdateData(FALSE);
	}
	SetModified();
}

void CPPgBackup::OnEnChangeBackupDir()
{
		SetModified();
}

void CPPgBackup::OnBnClickedBackupnow()
{
	OnApply();
	g_eMuleApp.m_pdlgEmule->RunBackupNow(false);
}

void CPPgBackup::OnBnClickedSelectall()
{
	datFiles = TRUE;
	metFiles = TRUE;
	iniFiles = TRUE;
	partFiles = TRUE;
	partMetFiles = TRUE;
	backupNowButton.EnableWindow(true);
	UpdateData(FALSE);
	SetModified();
}

void CPPgBackup::OnBnClickedAutobackup()
{
	SetModified();

	//Avoid 2 backups at the same time
	if(guardian) 
		return;
	guardian=true;

	UpdateData(TRUE);
	backupNowButton.EnableWindow(autoBackup);	

	guardian=false;
}

void CPPgBackup::CheckBackupNowButton()
{
	UpdateData(TRUE);
	backupNowButton.EnableWindow(datFiles || metFiles || iniFiles || partFiles || partMetFiles);
	OnBnClickedScheduledBackupCheck();
	SetModified();
}

bool CPPgBackup::SelectDir(TCHAR* outdir, CString titletext)
{
	CoInitialize(0);
	bool done;
	TCHAR* buffer = new TCHAR[MAX_PATH];
	BROWSEINFO bi = { GetSafeHwnd(), 0, buffer, titletext, BIF_VALIDATE | BIF_NEWDIALOGSTYLE | BIF_RETURNONLYFSDIRS, 0, 0, 0};
	LPITEMIDLIST pidl = SHBrowseForFolder(&bi);
	delete[] buffer;
	done = SHGetPathFromIDList(pidl,outdir);
	LPMALLOC ppMalloc;
	if(SHGetMalloc(&ppMalloc) == NOERROR)
	{
		ppMalloc->Free(pidl);
		ppMalloc->Release();
	}
	CoUninitialize();
	return done;
}

void CPPgBackup::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_BACKUP));
		GetResString(&backupTypeDesc, IDS_BACKUP_GRPFILETYPE);
		selectAllButton.SetWindowText(GetResString(IDS_BACKUP_SELECTALL));
		backupNowButton.SetWindowText(GetResString(IDS_BACKUP_NOW));
		GetResString(&backupOptionDesc, IDS_BACKUP_OPTION);
		GetResString(&backupDirDesc, IDS_BACKUP_TITLETXT);
		overwriteFilesCheck.SetWindowText(GetResString(IDS_BACKUP_OVERWRITE));		
		autoBackupCheck.SetWindowText(GetResString(IDS_BACKUP_AUTO));	
		scheduledBackupCheck.SetWindowText(GetResString(IDS_SCHEDULED_BACKUP));
		GetResString(&hours, IDS_HOURS);

		UpdateData(FALSE);
	}
}

void CPPgBackup::LoadSettings(void)
{
	if(::IsWindow(m_hWnd))
	{		
		datFiles = m_pPrefs->GetBackupDatFiles();
		metFiles = m_pPrefs->GetBackupMetFiles();
		iniFiles = m_pPrefs->GetBackupIniFiles();
		partFiles = m_pPrefs->GetBackupPartFiles();
		partMetFiles = m_pPrefs->GetBackupPartMetFiles();
		autoBackup = m_pPrefs->IsAutoBackup();
		overwriteFiles = m_pPrefs->GetBackupOverwrite();
		backupDir = m_pPrefs->GetBackupDir();
		scheduledBackup = m_pPrefs->IsScheduledBackup();
		scheduledBackupInterval.Format(_T("%d"), m_pPrefs->GetScheduledBackupInterval());

		UpdateData(FALSE);
		Localize();
	}
}

BOOL CPPgBackup::OnApply()
{
	if (m_bModified)
	{
		UpdateData(TRUE);

		m_pPrefs->SetBackupDatFiles(datFiles);
		m_pPrefs->SetBackupMetFiles(metFiles);
		m_pPrefs->SetBackupIniFiles(iniFiles);
		m_pPrefs->SetBackupPartFiles(partFiles);
		m_pPrefs->SetBackupPartMetFiles(partMetFiles);
		m_pPrefs->SetAutoBackup(autoBackup);
		m_pPrefs->SetBackupOverwrite(overwriteFiles);
		m_pPrefs->SetScheduledBackup(scheduledBackup);
		int sbi = _tstoi(scheduledBackupInterval);
		m_pPrefs->SetScheduledBackupInterval(sbi);

		if (backupDir.GetLength() != 0)
			m_pPrefs->SetBackupDir(backupDir);
	}
	return CPropertyPage::OnApply();
}

void CPPgBackup::OnBnClickedScheduledBackupCheck()
{
	UpdateData(TRUE);
	scheduledBackupCheck.EnableWindow(datFiles || metFiles || iniFiles || partFiles || partMetFiles);
	scheduledBackupEdit.EnableWindow(scheduledBackup && (datFiles || metFiles || iniFiles || partFiles || partMetFiles));

	SetModified();
}
